chiark / gitweb /
init/tripe-init.in: Whitespace fixups.
[tripe] / init / tripe-init.in
CommitLineData
0fa31a96 1#! /bin/sh
4ce4c726
MW
2###
3### tripe init script
4### suitable for direct use in most SysV-style inits
5
6### BEGIN INIT INFO
7# Provides: tripe
8# Required-Start: $local_fs $remote_fs $named $network
9# Required-Stop: $local_fs $remote_fs $network
10# Default-Start: 2 3 4 5
11# Default-Stop: 0 1 6
12# Short-Description: tripe Virtual Private Network server
13### END INIT INFO
0fa31a96 14
0fa31a96 15set -e
16
4ce4c726
MW
17###--------------------------------------------------------------------------
18### Configuration.
0fa31a96 19
ef4a1ab7 20[ -f @initconfig@ ] && . @initconfig@
4ce4c726 21
ef4a1ab7 22: ${prefix=@prefix@} ${exec_prefix=@exec_prefix@}
23: ${bindir=@bindir@} ${sbindir=@sbindir@}
797cf76b 24: ${TRIPEDIR=@configdir@} ${TRIPESOCK=@socketdir@/tripesock}
3cdc3f3a 25: ${pidfile=@pidfile@}
ef4a1ab7 26: ${tripe=$sbindir/tripe} ${tripectl=$bindir/tripectl}
4ce4c726 27
0fa31a96 28PATH=/usr/bin:/usr/sbin:/bin:/sbin:$bindir
4ce4c726 29export PATH TRIPEDIR TRIPESOCK TRIPE_SLIPIF
ef4a1ab7 30
4ce4c726
MW
31###--------------------------------------------------------------------------
32### Pre-flight checks.
3cdc3f3a 33
4ce4c726
MW
34## Give up if there's no binary.
35if test ! -x "$tripe" || test ! -x "$tripectl"; then
36 echo >&2 "Not starting/stopping TrIPE: binary files missing"
37 exit 0
38fi
39
40## Give up if there's no key.
41if test ! -f "$TRIPEDIR/keyring" || test ! -f "$TRIPEDIR/keyring.pub"; then
3cdc3f3a 42 echo >&2 "Not starting/stopping TrIPE: keyring files missing"
43 exit 0
44fi
45
4ce4c726
MW
46## Check it will work, or at least stands a fighting chance.
47##
48## (Having loads of different tunnel types doesn't help any.)
49case ${tunnel-`$tripe --tunnels | head -1`},`uname -s` in
50
51 ## Linux TUN/TAP.
52 linux,Linux)
53 if { test -f /proc/misc && grep -q tun /proc/misc; } ||
54 modprobe -q tun; then
55 : good
56 else
57 echo >&2 "$tripe needs the Linux TUN/TAP driver to run."
58 exit 1
59 fi
60 if test -c /dev/net/tun; then
61 : good
62 else
63 echo >&2 "$tripe needs /dev/net/tun, which is missing."
64 exit 1
65 fi
ef4a1ab7 66 ;;
4ce4c726
MW
67
68 ## Linux Unet (obsolete).
69 unet,Linux)
70 if { test -f /proc/devices && grep -q unet /proc/devices; } ||
71 modprobe -q unet; then
72 : good
73 else
74 echo >&2 "$tripe needs the Linux UNET driver to run."
75 exit 1
76 fi
77 if test -c /dev/unet; then
78 : good
79 else
80 echo >&2 "$tripe needs /dev/unet, which is missing."
81 exit 1
82 fi
ef4a1ab7 83 ;;
4ce4c726
MW
84
85 ## BSD tun.
86 bsd,*BSD)
87 ## Don't know how to check the device is working. Check the device file
88 ## exists and hope for the best.
89 if test -c /dev/tun0; then
90 : good
91 else
92 echo >&2 "$tripe needs /dev/tun0, which is missing."
93 exit 1
94 fi
ef4a1ab7 95 ;;
4ce4c726
MW
96
97 ## SLIP.
98 slip,*)
b9066fbb 99 if test "$TRIPE_SLIPIF" = ""; then
100 echo >&2 "$tripe needs SLIP interfaces set up!"
101 exit 1
102 fi
103 ;;
4ce4c726
MW
104
105 ## Various kinds of misconfiguration.
106 linux,* | unet,*)
107 echo >&2 "CONFIGURATION ERROR"
108 echo >&2 " $tripe is compiled to use a Linux tunnel device, but"
109 echo >&2 " this system is `uname -s`"
110 exit 1
111 ;;
112 bsd,*)
113 echo >&2 "CONFIGURATION ERROR"
114 echo >&2 " $tripe is compiled to use a BSD tunnel device, but"
115 echo >&2 " this system is `uname -s`"
116 exit 1
117 ;;
ef4a1ab7 118esac
e04c2d50 119
4ce4c726
MW
120###--------------------------------------------------------------------------
121### Do what was wanted.
0fa31a96 122
123case "$1" in
4ce4c726 124
0fa31a96 125 start)
126 echo -n "Starting TrIPE VPN daemon:"
4ce4c726
MW
127
128 ## Check to see whether the daemon is already going. If it can respond
129 ## to a simple request, we'll assume that it is.
3cdc3f3a 130 if $tripectl version >/dev/null 2>/dev/null; then
0fa31a96 131 echo " already running"
132 exit 0
133 fi
4ce4c726
MW
134
135 ## Start the server, passing lots of arguments.
ef4a1ab7 136 $tripectl -D -s -p$tripe \
137 -f${logfile-@logfile@} \
3cdc3f3a 138 -P$pidfile \
52c03a2a 139 ${keytag+-S-t}$keytag \
0fa31a96 140 ${addr+-S-b}$addr \
141 ${port+-S-p}${port} \
ab46a787
MW
142 ${user+-U}${user} \
143 ${group+-G}${group} \
0fa31a96 144 ${trace+-S-T}${trace} \
42da2a58 145 ${tunnel+-S-n}${tunnel} \
0fa31a96 146 ${miscopts}
4ce4c726
MW
147
148 ## Wait for the server to start up. This doesn't usually take long.
0fa31a96 149 for i in 1 2 3 4 give-up; do
150 $tripectl help >/dev/null 2>/dev/null && break
151 sleep 1
152 done
4ce4c726 153
0fa31a96 154 if [ $i = give-up ]; then
155 echo " wouldn't start"
156 exit 1
157 fi
4ce4c726 158
0fa31a96 159 echo -n " tripe"
4ce4c726
MW
160
161 ## Start up the ancillary services.
a62f8e8a
MW
162 sep=" services [" end=""
163 [ -d $TRIPEDIR/services ] && for i in $TRIPEDIR/services/*; do
164 [ -x $i ] || continue
165 name=`basename $i`
166 case $name in *~|\#*) continue;; esac
167 if $i --daemon --startup; then
168 echo -n "$sep$name"
169 else
a571143b 170 echo -n "$sep($name failed)"
a62f8e8a
MW
171 fi
172 sep=" " end="]"
173 done
174 echo -n "$end"
4ce4c726
MW
175
176 ## Start up the statically configured peers.
a62f8e8a
MW
177 sep=" peers [" end=""
178 [ -d $TRIPEDIR/peers ] && for i in $TRIPEDIR/peers/*; do
595935b7 179 [ -x $i ] || continue
0fa31a96 180 name=`basename $i`
595935b7 181 case $name in *~|\#*) continue;; esac
e04c2d50 182 if $i; then
a62f8e8a 183 echo -n "$sep$name"
595935b7 184 else
a571143b 185 echo -n "$sep($name failed)"
595935b7 186 fi
a62f8e8a 187 sep=" " end="]"
0fa31a96 188 done
4ce4c726
MW
189
190 ## Happy.
a62f8e8a 191 echo "$end done"
0fa31a96 192 ;;
4ce4c726 193
0fa31a96 194 stop)
195 echo -n "Stopping TrIPE VPN daemon:"
4ce4c726
MW
196
197 ## If there's no socket, it must have quit (probably nonviolently).
797cf76b 198 if test ! -S $TRIPESOCK; then
3cdc3f3a 199 echo " not running"
4ce4c726
MW
200
201 ## Ask it to die nicely.
3cdc3f3a 202 elif $tripectl quit >/dev/null 2>&1; then
203 echo " done"
4ce4c726
MW
204
205 ## If there's no pidfile then tripectl presumably deleted it.
3cdc3f3a 206 elif test ! -f $pidfile; then
207 echo " stale socket found: removing"
797cf76b 208 rm -f $TRIPESOCK
4ce4c726
MW
209
210 ## Otherwise kill the process unpleasantly.
3cdc3f3a 211 elif kill `cat $pidfile`; then
212 echo " done (killed violently)"
213 else
819018a9 214 echo " it doesn't want to die!"
3cdc3f3a 215 exit 1
216 fi
0fa31a96 217 ;;
4ce4c726 218
ef4a1ab7 219 status)
220 for i in `$tripectl list`; do
221 echo "Peer \`$i':"
222 $tripectl stats $i | sed 's/^/ /'
223 done
224 ;;
4ce4c726 225
de014da6 226 reload)
227 $tripectl reload
228 echo "Keyrings reloaded OK."
229 ;;
4ce4c726 230
0fa31a96 231 restart | force-reload)
232 sh $0 stop
233 sh $0 start
234 ;;
4ce4c726 235
0fa31a96 236 *)
de014da6 237 echo >&2 "usage: $0 start|stop|restart|status|reload|force-reload"
0fa31a96 238 exit 1
239 ;;
4ce4c726 240
0fa31a96 241esac
4ce4c726
MW
242
243###----- That's all, folks --------------------------------------------------